# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_without maven

%define section free

Name:           plexus-compiler
Version:        1.8.2
Release:        1%{?dist}
Epoch:          0
Summary:        Plexus Compiler
License:        ASL 2.0
Group:          Development/Java
URL:            http://plexus.codehaus.org/
# git clone https://github.com/sonatype/plexus-compiler.git && cd plexus-compiler && git archive --prefix="plexus-compiler-1.8.2/" --format=tar plexus-compiler-1.8.2 | bzip2 > ../plexus-compiler-1.8.2.tar.bz2
Source0:        plexus-compiler-1.8.2.tar.bz2
Source1:        plexus-compiler-1.8.1-autogenerated-files.tar.gz
Source2:        http://mirrors.ibiblio.org/pub/mirrors/maven2/org/codehaus/plexus/plexus-components/1.1.18/plexus-components-1.1.18.pom
Patch0:         plexus-compiler-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       aspectj >= 0:1.5.3
Requires:       classworlds
Requires:       commons-lang
Requires:       ecj3
Requires:       jpackage-utils
Requires:       junit
Requires:       plexus-containers-component-metadata
Requires:       plexus-containers-container-default
Requires:       plexus-utils
BuildRequires:  commons-lang
BuildRequires:  jpackage-utils
BuildRequires:  java-1.6.0-devel
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  ant-nodeps
%if %with maven
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  jmock
BuildRequires:  plexus-maven-plugin >= 0:1.3.5
%endif
BuildRequires:  aspectj >= 0:1.5.3
BuildRequires:  classworlds
BuildRequires:  ecj3
BuildRequires:  junit
BuildRequires:  maven-wagon
BuildRequires:  plexus-containers-container-default
BuildRequires:  plexus-containers-component-metadata
BuildRequires:  plexus-utils
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Plexus Compiler components.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
Javadoc for %{name}.

%prep
%setup -q 
%patch0 -p0 -b .sav0
%if %without maven
gzip -dc %{SOURCE1} | tar xf -
%endif

%build
%if %with maven
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}/JPP/maven2/default_poms/
cp -p %{SOURCE2} ${MAVEN_REPO_LOCAL}/JPP/maven2/default_poms/JPP-components.pom
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.test.failure.ignore install javadoc:aggregate

%else
mkdir -p ${MAVEN_REPO_LOCAL}/org/codehaus/plexus/plexus-utils/1.4.8/
ln -sf $(build-classpath plexus/utils) ${MAVEN_REPO_LOCAL}/org/codehaus/plexus/plexus-utils/1.4.8/plexus-utils-1.4.8.jar
mkdir -p ${MAVEN_REPO_LOCAL}/junit/junit/3.8.1/
ln -sf $(build-classpath junit) ${MAVEN_REPO_LOCAL}/junit/junit/3.8.1/junit-3.8.1.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/codehaus/plexus/plexus-container-default/1.0-alpha-9-stable-1/
ln -sf $(build-classpath plexus/container-default) ${MAVEN_REPO_LOCAL}/org/codehaus/plexus/plexus-container-default/1.0-alpha-9-stable-1/plexus-container-default-1.0-alpha-9-stable-1.jar
mkdir -p ${MAVEN_REPO_LOCAL}/classworlds/classworlds/1.1/
ln -sf $(build-classpath classworlds) ${MAVEN_REPO_LOCAL}/classworlds/classworlds/1.1/classworlds-1.1.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-model/2.0.7/
ln -sf $(build-classpath maven2/model) ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-model/2.0.7/maven-model-2.0.7.jar
mkdir -p ${MAVEN_REPO_LOCAL}/commons-lang/commons-lang/2.3/
ln -sf $(build-classpath commons-lang) ${MAVEN_REPO_LOCAL}/commons-lang/commons-lang/2.3/commons-lang-2.3.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-repository-metadata/2.0.7/
ln -sf $(build-classpath maven2/repository-metadata) ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-repository-metadata/2.0.7/maven-repository-metadata-2.0.7.jar
mkdir -p ${MAVEN_REPO_LOCAL}/jdom/jdom/1.0/
ln -sf $(build-classpath jdom) ${MAVEN_REPO_LOCAL}/jdom/jdom/1.0/jdom-1.0.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-artifact-manager/2.0.7/
ln -sf $(build-classpath maven2/artifact-manager) ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-artifact-manager/2.0.7/maven-artifact-manager-2.0.7.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-artifact-test/2.0.7/
ln -sf $(build-classpath maven2/artifact-test) ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-artifact-test/2.0.7/maven-artifact-test-2.0.7.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-artifact/2.0.7/
ln -sf $(build-classpath maven2/artifact) ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-artifact/2.0.7/maven-artifact-2.0.7.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-settings/2.0.7/
ln -sf $(build-classpath maven2/settings) ${MAVEN_REPO_LOCAL}/org/apache/maven/maven-settings/2.0.7/maven-settings-2.0.7.jar
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/maven/wagon/wagon-provider-api/1.0/
ln -sf $(build-classpath maven-wagon/provider-api) ${MAVEN_REPO_LOCAL}/org/apache/maven/wagon/wagon-provider-api/1.0/wagon-provider-api-1.0.jar
mkdir -p ${MAVEN_REPO_LOCAL}/aspectj/aspectjrt/1.2.1/
ln -sf $(build-classpath aspectjrt) ${MAVEN_REPO_LOCAL}/aspectj/aspectjrt/1.2.1/aspectjrt-1.2.1.jar
mkdir -p ${MAVEN_REPO_LOCAL}/aspectj/aspectjtools/1.2.1/
ln -sf $(build-classpath aspectjtools) ${MAVEN_REPO_LOCAL}/aspectj/aspectjtools/1.2.1/aspectjtools-1.2.1.jar
mkdir -p $HOME/.m2/repository/aspectj/aspectjrt/1.5.0/
ln -sf $(build-classpath aspectjrt) $HOME/.m2/repository/aspectj/aspectjrt/1.5.0/aspectjrt-1.5.0.jar
mkdir -p $HOME/.m2/repository/aspectj/aspectjtools/1.5.0/
ln -sf $(build-classpath aspectjtools) $HOME/.m2/repository/aspectj/aspectjtools/1.5.0/aspectjtools-1.5.0.jar
mkdir -p $HOME/.m2/repository/commons-lang/commons-lang/2.0/
ln -sf $(build-classpath commons-lang) $HOME/.m2/repository/commons-lang/commons-lang/2.0/commons-lang-2.0.jar

unset CLASSPATH
pushd plexus-compiler-api
%{ant} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.settings.offline=true jar javadoc
popd

pushd plexus-compiler-manager
%{ant} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.settings.offline=true jar javadoc
popd

pushd plexus-compiler-test
%{ant} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.settings.offline=true jar javadoc
popd

pushd plexus-compilers

pushd plexus-compiler-aspectj
ECLIPSE_JAR=$(ls /usr/share/eclipse/plugins/org.eclipse.equinox.common_*.jar) && export CLASSPATH=$(ls /usr/share/eclipse/plugins/org.eclipse.equinox.common_*.jar)
%{ant} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.settings.offline=true jar javadoc
popd

pushd plexus-compiler-csharp
%{ant} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.settings.offline=true jar javadoc
popd

pushd plexus-compiler-eclipse
export CLASSPATH=$(build-classpath ecj)
%{ant} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.settings.offline=true jar javadoc
popd

pushd plexus-compiler-javac
%{ant} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.settings.offline=true jar javadoc
popd

pushd plexus-compiler-jikes
%{ant} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven.settings.offline=true jar javadoc
popd
popd
%endif

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -pm 644 plexus-compiler-api/target/plexus-compiler-api-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-api-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus plexus-compiler-api %{version} JPP %{name}-api
%if %with maven
install -pm 644 plexus-compiler-test/target/plexus-compiler-test-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-test-%{version}.jar
%endif
%add_to_maven_depmap org.codehaus.plexus plexus-compiler-test %{version} JPP %{name}-test
install -pm 644 plexus-compiler-manager/target/plexus-compiler-manager-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-manager-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus plexus-compiler-manager %{version} JPP %{name}-manager

%add_to_maven_depmap org.codehaus.plexus plexus-compilers %{version} JPP plexus-compilers

install -pm 644 plexus-compilers/plexus-compiler-aspectj/target/plexus-compiler-aspectj-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-aspectj-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus plexus-compiler-aspectj %{version} JPP %{name}-aspectj
install -pm 644 plexus-compilers/plexus-compiler-csharp/target/plexus-compiler-csharp-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-csharp-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus plexus-compiler-csharp %{version} JPP %{name}-csharp
install -pm 644 plexus-compilers/plexus-compiler-eclipse/target/plexus-compiler-eclipse-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-eclipse-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus plexus-compiler-eclipse %{version} JPP %{name}-eclipse
install -pm 644 plexus-compilers/plexus-compiler-javac/target/plexus-compiler-javac-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-javac-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus plexus-compiler-javac %{version} JPP %{name}-javac
install -pm 644 plexus-compilers/plexus-compiler-jikes/target/plexus-compiler-jikes-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-jikes-%{version}.jar
%add_to_maven_depmap org.codehaus.plexus plexus-compiler-jikes %{version} JPP %{name}-jikes
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-plexus-compilers.pom
install -pm 644 plexus-compiler-api/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-api.pom
install -pm 644 plexus-compiler-test/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-test.pom
install -pm 644 plexus-compiler-manager/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-manager.pom
install -pm 644 plexus-compilers/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-compilers.pom
install -pm 644 plexus-compilers/plexus-compiler-aspectj/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-aspectj.pom
install -pm 644 plexus-compilers/plexus-compiler-csharp/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-csharp.pom
install -pm 644 plexus-compilers/plexus-compiler-eclipse/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-eclipse.pom
install -pm 644 plexus-compilers/plexus-compiler-javac/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-javac.pom
install -pm 644 plexus-compilers/plexus-compiler-jikes/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-jikes.pom

# javadoc
%if 0
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/api
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/manager
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/test
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/aspectj
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/csharp
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/eclipse
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/javac
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/jikes
cp -pr plexus-compiler-api/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/api
cp -pr plexus-compiler-manager/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/manager
%if %with maven
cp -pr plexus-compiler-test/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/test
%endif
cp -pr plexus-compilers/plexus-compiler-aspectj/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/aspectj
cp -pr plexus-compilers/plexus-compiler-csharp/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/csharp
cp -pr plexus-compilers/plexus-compiler-eclipse/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/eclipse
cp -pr plexus-compilers/plexus-compiler-javac/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/javac
cp -pr plexus-compilers/plexus-compiler-jikes/target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/compilers/jikes
%else
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s plexus-compiler-%{version} %{buildroot}%{_javadocdir}/%{name}
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/plexus-*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/plexus-compiler

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Wed Jul 20 2011 David Walluck <dwalluck@redhat.com> 0:1.8.2-1
- 1.8.2
- fix Requires
- use real jar names
- fix maven option
- remove GCJ support

* Tue Dec 21 2010 Ralph Apel <r.apel at r-apel.de> - 0:1.8.1-1
- 1.8.1
- (B)R ecj3

* Mon Mar 02 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.5.3-3.jpp5
- Rebuild once with ant

* Fri Feb 27 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.5.3-2.jpp5
- Add one pom and depmap frag

* Thu Jan 03 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.5.3-1jpp
- 1.5.3

* Sat Mar 24 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.5.2-5jpp
- Fix post/postun

* Wed Mar 21 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.5.2-4jpp
- Add current maven2 dep management and poms

* Tue Mar 20 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.5.2-3jpp
- (B)R ecj instead of eclipse-ecj
- Go for full maven2 build
- Add gcj_support option

* Fri Jun 02 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.5.2-2jpp
- Fix jar naming to previous plexus conventions

* Tue May 30 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.5.2-1jpp
- First JPackage build
